Package org.apache.storm.grouping

## Class ShuffleGrouping

- java.lang.Object
- - org.apache.storm.grouping.ShuffleGrouping

- All Implemented Interfaces:
    `Serializable`, `CustomStreamGrouping`

      public class ShuffleGrouping
      extends Object
      implements CustomStreamGrouping, Serializable

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ShuffleGrouping()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `List<Integer>` | `chooseTasks​(int taskId, List<Object> values)` | This function implements a custom stream grouping.
    `void` | `prepare​(WorkerTopologyContext context, GlobalStreamId stream, List<Integer> targetTasks)` | Tells the stream grouping at runtime the tasks in the target bolt.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ShuffleGrouping

          public ShuffleGrouping()

  - ### Method Detail

    - #### prepare

          public void prepare​(WorkerTopologyContext context,
                              GlobalStreamId stream,
                              List<Integer> targetTasks)

      Description copied from interface: `CustomStreamGrouping`
      Tells the stream grouping at runtime the tasks in the target bolt. This information should be used in chooseTasks to determine the target tasks.

      It also tells the grouping the metadata on the stream this grouping will be used on.

      Specified by:
        `prepare` in interface `CustomStreamGrouping`

    - #### chooseTasks

          public List<Integer> chooseTasks​(int taskId,
                                           List<Object> values)

      Description copied from interface: `CustomStreamGrouping`
      This function implements a custom stream grouping. It takes in as input the number of tasks in the target bolt in prepare and returns the tasks to send the tuples to.
      Specified by:
        `chooseTasks` in interface `CustomStreamGrouping`
        `values` - the values to group on